#!/usr/bin/perl
########################################################################
#
#  colsToVectors.pl
#
#  Convert two whitespace-delimited columns to R vectors.
#
#  Input:  
#      <x1> <y1>
#       :    :
#      <xn> <yn>
#
#  Output:
#      (x1, ..., xn)
#      (y1, ..., yn)
#
#  E. Moreton  *  UNC-Chapel Hill Linguistics  *  2019 October 14 (M)
#
########################################################################

use strict;
use warnings;

sub vect {
    my $v = join (", ", @_);
    return "($v)";
}

my (@xs, @ys);
while (<STDIN>) {
    chomp;
    my ($x, $y) = split /\s+/;
    push @xs, $x;
    push @ys, $y;
}

print &vect (@xs);
print "\n";
print &vect (@ys);
print "\n";
