#!/usr/bin/perl
########################################################################
#
#  mkmut.pl
#
#  Make a mutagen file for the SHJ 1961 simulations, with different
#  probabilities of adding vs. losing nodes.
#
#  E. Moreton  *  UNC-Chapel Hill Linguistics  *  2019 March 28 (Th)
#
########################################################################

use strict;
use warnings;


my @p = (0, 0.01, 0.015, 0.02, 0.025, 0.03, 0.04, 0.05, 0.1, 0.2, 0.3, 0.4, 0.5);
#my @qfactor = (2, 1.1, 1.01, 1, 0.99, 0.9, 0.5);

print "MutagenSet\n";
for my $p (@p) {
#    for my $qfactor (@qfactor) {
#	my $q = sprintf ("%5.4f", $p * $qfactor);

#    print "  Mutagen Mut_${p}_$qfactor\n";
    print "  Mutagen Mut_${p}\n";
    print <<MUT;
    P_mutate                         1
    P_invert_polarity                0
    P_add_constituent                0
    P_delete_constituent             0
    P_duplicate_constituent          0  
    P_gain_head                      0  
    P_lose_head                      0  
    P_move_head                      0  
    P_flip_anchor                    0
    P_gain_unary                     0
    P_lose_unary                     0
    P_gain_binary                    $p
    P_lose_binary                    $p
    P_invert_unary_coefficient       0
    P_invert_binary_coefficient      $p
    P_invert_PrCat_coefficient       0
    P_unary_feature_to_variable      0
    P_unary_variable_to_feature      0
    P_binary_feature_to_variable     0
    P_binary_variable_to_feature     0
    P_PrCat_to_PrCat_variable        0
    P_PrCat_variable_to_PrCat        0
MUT
#    }
}
