use FindBin;
use lib "$FindBin::Bin/../lib/";
use BinaryFeature;
use BinaryFeatureVariable;
use GJ2005jr;

use RecombinatorSet;

open (REC, "<Const.rec") or die "Couldn't open Const.rec";
my $recset = &RecombinatorSet::from_text (<REC>);
my $rec = $recset->get_recombinator_named ("Rec.0.50");

print "--- A ---\n";
($A, $depth, $is_head) = BinaryFeature::from_text ("*+nasal*");
print "Original:\n";
$A->print ($depth, $is_head);
($A_prime, $depth, $is_head) = BinaryFeature::from_text (
    $A->to_text ($depth, $is_head));
print "Reconstituted:\n";
$A_prime->print ($depth, $is_head);
print "As flat string:\n";
print $A->to_flat_string ($is_head);
print "\n";


print "--- B ---\n";
$B = (BinaryFeature::from_text ("[-high]")) [0];
$B->print;

print "class: ", (ref $B), "\n";

print "--- A+B ---\n";
$C = $A->breed ($B, $rec);
if (ref ($C) and $C->can ("print")) {
    $C->print;
} else {
    print "$C\n";
}
