use FindBin;
use lib "$FindBin::Bin/../lib/";
use Globals;
use CELEX;
use ConstraintSet;
use MutagenSet;
use RecombinatorSet;

$confile = "./SomeConstraints";
#$confile = "./test.BreedingMutationConstraints";
($cons) = &ConstraintSet::from_text (
    &Globals::read_text ("$confile.txt")
    );

open (MUT, "<Const.mut") or die "Couldn't open Const.mut";
my $mutset = &MutagenSet::from_text (<MUT>);
my $mut = $mutset->get_mutagen_named ("Random");
$mut->protect_PrCat_parents;
$mut->protect_feature_parents;

open (REC, "<Const.rec") or die "Couldn't open Const.rec";
my $recset = &RecombinatorSet::from_text (<REC>);
my $rec = $recset->get_recombinator_named ("Rec.0.50");



@constraints = $cons->get_all;
for my $i (1..100) {
    print "===================================\n";
    $mom = $constraints [$i-1];
    $dad = $constraints [$i];
    $kid = $mom->breed ($dad, $rec);
    $mutant = $kid->mutant ($mut);
    print "MOM:  "; $mom->print;
#    print $mom->to_tree;
    print "DAD:  "; $dad->print;
#    print $dad->to_tree;
    print "KID:  "; $kid->print;
#    print $kid->to_tree;
    print "MUTANT:  "; $mutant->print;
#    print $mutant->to_tree;
}
