use FindBin;
use lib "$FindBin::Bin/../lib/";
use CELEX;
use GJ2005jr;
use PrCat;
use Mutagen;
use Recombinator;

# The constraint for the HH condition:
$HH = &GJ2005jr::get ('PrWd')->double_anchored;
$HH->put_head (&GJ2005jr::get ('Syll')->unanchored);
$HH->put_head (&GJ2005jr::get ('Root')->plus, 
	          &GJ2005jr::get ('Place')->plus,
   	              &GJ2005jr::get ('Dor')->plus,
	                  &GJ2005jr::get ('high')->plus ('alpha')
	      );
$HH->put (&GJ2005jr::get ('Syll')->unanchored);
$HH->put_head (&GJ2005jr::get ('Root')->plus, 
	          &GJ2005jr::get ('Place')->plus,
   	              &GJ2005jr::get ('Dor')->plus,
	                  &GJ2005jr::get ('high')->plus ('alpha')
	      );
$HH->print;

$scale = 1;
$mut = new Mutagen (
    P_mutate                       => $scale * 1,
    P_invert_polarity              => $scale * 0.00,
    P_add_constituent              => $scale * 0.025,
    P_delete_constituent           => $scale * 0.025,
    P_duplicate_constituent        => $scale * 0.025,
    P_gain_head                    => $scale * 0, 
    P_lose_head                    => $scale * 0,
    P_move_head                    => $scale * 0, 
    P_flip_anchor                  => $scale * 0.00,
    P_gain_unary                   => $scale * 0.05,
    P_lose_unary                   => $scale * 0.05,
    P_gain_binary                  => $scale * 0.05,
    P_lose_binary                  => $scale * 0.05,
    P_invert_unary_coefficient     => $scale * 0.05,
    P_invert_binary_coefficient    => $scale * 0.05,
    P_invert_PrCat_coefficient     => $scale * 0.05,
    P_unary_feature_to_variable    => $scale * 0.00,
    P_unary_variable_to_feature    => $scale * 0.00,
    P_binary_feature_to_variable   => $scale * 0.00,
    P_binary_variable_to_feature   => $scale * 0.00,
    P_PrCat_to_PrCat_variable      => $scale * 0.00,
    P_PrCat_variable_to_PrCat      => $scale * 0.00
    );

$rec = new Recombinator (
    P_this_wins => 0.5,
    P_null_wins => 0.5
    );


# Mutate an GJ2005jr word into a new word
sub mutate_word {
    my $ipa = shift;
    my $mutant_ipa;
    my $times;
    while (1) {
	my $mutant = new Constraint ($rep, +1)->mutant ($mut)->get_target;
	$mutant_ipa = &GJ2005jr::to_IPA ($mutant);
	next if ($mutant_ipa eq $ipa);
	next if ($mutant_ipa =~ /\?/);   # Non-ASCII-GJ2005jr character
	last;
    }
    $mutant_ipa;
}

# Breed two GJ2005jr words
sub breed_words {
    my ($one, $two, $rec) = @_;
    my $three;
    while (1) {
	my $one_rep   = &GJ2005jr::to_representation ($one);
	my $two_rep   = &GJ2005jr::to_representation ($two);
	my $three_rep = $one_rep->breed ($two_rep, $rec);

	print $three_rep->to_text;
	print "\n";

	$three = &GJ2005jr::to_IPA ($three_rep);
	next if ($three =~ /\?/);   # Non-ASCII-GJ2005jr character
	last;
    }
    $three;
}

$infile = (shift @ARGV);
$infile = "EPW.words" unless $infile;

open (IN, "< $infile") or die "Couldn't open $infile: $!";


my @words;
while (<IN>) {
    @fields = split;
    $pron = $fields [-1];
#    print "===", (join ' ', @fields), "===\n";
    $rep = CELEX::to_representation ($pron);

    push @words, &GJ2005jr::to_IPA ($rep);

#    print 0+$HH->matches_in ($rep), "\n";    

#    print (join "\n", $rep->to_text); print "\n";
#    my $ipa = &GJ2005jr::to_IPA ($rep);
#    print "IPA:  $ipa\n";
#    my $rerep = &GJ2005jr::to_representation ($ipa);
#    print (join "\n", $rerep->to_text); print "\n";
#    my $repron = &GJ2005jr::to_IPA ($rerep);
#    print "$repron\n";

#    print &mutate_word ($ipa);
#    print "\n";

}


my $one = $words [rand (@words)];
my $two = $words [rand (@words)];
my $three = &breed_words ($one, $two, $rec);
print "$one + $two = $three\n";
