use FindBin;
use lib "$FindBin::Bin/../lib/";
use Globals;
use GJ2005jr;
use ConstraintSet;
use StimulusSet;
use Stimulus;
use Mutagen;

$confile = "./SomeConstraints";
$wordfile = "./SomeWords";

($cons) = &ConstraintSet::from_text (
    &Globals::read_text ("$confile.txt")
    );

$cons->print;
#@deleted = $cons->delete_random (12);
#$cons->print;

print "As flat string:\n";
print $cons->to_flat_string;
print "\n";

@words = (&Globals::read_text ("$wordfile.txt"));

($words) = &StimulusSet::from_text (
    "StimulusSet",
    map {
	new Stimulus (
	    &GJ2005jr::to_representation ($_),
	    1, 1)->to_text (1)
    } @words
    );


# Does conversion to and from text cause problems?
if (1) {
    open (CONTEXT1, "> $confile.1.txt") or
	die "Couldn't open $confile.1.txt: $!";
    open (CONTEXT2, "> $confile.2.txt") or
	die "Couldn't open $confile.2.txt: $!";

    print CONTEXT1 join ("\n", $cons->to_text);
    ($cons_2) = &ConstraintSet::from_text ($cons->to_text);
    print CONTEXT2 join ("\n", $cons_2->to_text);
    
    open (WORDTEXT1, "> $wordfile.1.txt") or
	die "Couldn't open $wordfile.1.txt: $!";
    open (WORDTEXT2, "> $wordfile.2.txt") or
	die "Couldn't open $wordfile.2.txt: $!";



    print WORDTEXT1 join ("\n", $words->to_text);
    ($words_2) = &StimulusSet::from_text ($words->to_text);
    print WORDTEXT2 join ("\n", $words_2->to_text);
}
# Now use diff foo.1.txt foo.2.txt

# Apply constraints to each word
for my $word (@words) {
    chomp $word;
    print ":::::[$word]:::::\n";
    for my $con ($cons->get_all) {
	printf "    %3d %s\n", 
	$con->score (&GJ2005jr::to_representation ($word)),
	$con->get_name;
    }
}

    
