use FindBin;
use lib "$FindBin::Bin/../lib/";
use CELEX;
use GJ2005jr;
use Constraint;

my $wtf = &Constraint::from_text (
"-Constraint",
"  (- Prosodic Word -)",
"    *L Syllable R*",
"      [+Root]",
"        [+Laryngeal]",
"          [-voiced]",
"        [+Place]",
"        [-approximant]",
"        [-continuant]",
"        [-lateral]",
"        [-nasal]",
"        [-sonorant]",
"        [-syllabic]",
"      *+Root*",
"        [+Laryngeal]",
"          [+voiced]",
"        [+Place]",
"          [+Dorsal]",
"        [-consonantal]",
"        [-lateral]",
"        [-nasal]",
"        [+syllabic]"
    );

my $wtf = &Constraint::from_text (
"-Constraint",
"  (L Prosodic Word -)",
"    *L Syllable R*",
"      [+Root]",
"        [+Laryngeal]",
"          [+spread glottis]",
"        [+consonantal]",
"        [-nasal]",
"        [-sonorant]",
"      *+Root*",
"        [+Laryngeal]",
"          [-spread glottis]",
"        [+Place]"
    );



$wtf->print;

$V = "i";
for $C (qw/ p f b v t T d D x G /) {
    my $CELEX = "$C $V";
    print "[$CELEX]:  wtf:";
    $rep = &GJ2005jr::to_representation ($CELEX);

    print $wtf->score ($rep); print "\n";
    $rep->print;
    print "\n";
}


