use FindBin;
use lib "$FindBin::Bin/../lib/";
use GJ2005jrFM;
use Globals;
use ConstraintSet;
use Mutagen;

$confile = "./SomeConstraints";
($cons) = &ConstraintSet::from_text (
    &Globals::read_text ("$confile.txt")
    );

print (join "\n", $cons->to_text);
print "\n\n";


$scale = 1;
$mut = new Mutagen (
    P_mutate                       => $scale * 1,
    P_invert_polarity              => $scale * 0.05,
    P_add_constituent              => $scale * 0.025,
    P_delete_constituent           => $scale * 0.025,
    P_duplicate_constituent        => $scale * 0,
    P_gain_head                    => $scale * 0, 
    P_lose_head                    => $scale * 0,
    P_move_head                    => $scale * 0, 
    P_flip_anchor                  => $scale * 0.025,
    P_gain_unary                   => $scale * 0.05,
    P_lose_unary                   => $scale * 0.05,
    P_gain_binary                  => $scale * 0.05,
    P_lose_binary                  => $scale * 0.05,
    P_invert_unary_coefficient     => $scale * 0.05,
    P_invert_binary_coefficient    => $scale * 0.05,
    P_invert_PrCat_coefficient     => $scale * 0.05,
    P_unary_feature_to_variable    => $scale * 0.05,
    P_unary_variable_to_feature    => $scale * 0.05,
    P_binary_feature_to_variable   => $scale * 0.05,
    P_binary_variable_to_feature   => $scale * 0.05,
    P_PrCat_to_PrCat_variable      => $scale * 0.05,
    P_PrCat_variable_to_PrCat      => $scale * 0.05
    );
$mut->protect_PrCat_parents;
$mut->protect_feature_parents;

@constraints = $cons->get_all;
for my $i (1..100) {
    for (@constraints) {
	$_ = $_->mutant ($mut);
	print ((join "\n", $_->to_text (1)), "\n") if (rand (1) < 0.05);
    }
}
