use FindBin;
use lib "$FindBin::Bin/../lib/";
use Representations;
use Mutagen;

# Initialize representations

@text = &Globals::read_text ("../../New/lib/GJ2005jr.rep");
$rep = new Representations;
&Globals::set_representations ($rep);
$rep->from_text (@text);

# Initialize mutagen

open (MUT, "< ./Const.mut") or 
    die "Couldn't open mutagen: $!";

while (<MUT>) {
    my ($pname, $pval) = split;
    $probabilities {$pname} = $pval;
}

$mut = new Mutagen (%probabilities);


# Create some constraints

$PRWD = &Globals::get_representations->get ('PrWd');
$SYLL = &Globals::get_representations->get ('Syllable');

for (&Globals::get_representations->get_all_features) {
    $name = $_->get_abbrev;
    ${$name} = $_;
}

for ($PRWD->unanchored) {
    $_->put ($SYLL->right_anchored);
    $_->put ($Root->plus,
             $nas->plus,
             $Place->plus (alpha));
    $_->put ($SYLL->left_anchored);
    $_->put ($Root->plus,
             $cont->minus,
             $Place->plus (alpha));
    $C = new Constraint ($_, +1);
    $C->print;
}

my $all = 50;
my $bad;
for $i (1..$all) {
    $D = $C->clone;
    for $j (1..10) {
	$D = $D->mutant ($mut);
    }
    push @constraints, $D;
}

for (@constraints) {
    if (&Globals::get_representations->is_forbidden ($_->get_target)) {
	$bad++;
    }
}

print "$bad:$all = ", $bad/$all, "\n";
