use FindBin;
use lib "$FindBin::Bin/../lib/";
use Representations;
use Mutagen;

# Initialize representations

@text = &Globals::read_text ("SHJ1961.rep");
$rep = new Representations;
&Globals::set_representations ($rep);
$rep->from_text (@text);


# Initialize mutagen
open (MUT, "< ./Moreton2008.Exp6.unsup/Const.mut") or 
    die "Couldn't open mutagen: $!";

while (<MUT>) {
    my ($pname, $pval) = split;
    $probabilities {$pname} = $pval;
}

$mut = new Mutagen (%probabilities);


# Create some constraints

$Figure = &Globals::get_representations->get ('Figure');

$Figure->print;

for (&Globals::get_representations->get_all_features) {
    $name = $_->get_abbrev;
    print "Adding $name!  ";
    ${$name} = $_;
    print "It's $_!\n";
}

for ($Figure->double_anchored) {
    $_->put ($Root->plus, 
	     $blk->plus,
	     $big->plus,
	     $tri->minus);
    $C = new Constraint ($_, +1);
    $C->print;
}


my $all = 50;
my $bad;
for $i (1..$all) {
    $D = $C->clone;
    for $j (1..10) {
	$D = $D->mutant ($mut);
	$D->print;
    }
    push @constraints, $D;
}

print "=====\n";

for (@constraints) {

    print "Checking target\n";
    my $target = $_->get_target;
    $target->print;
    print "Done\n";

    if (&Globals::get_representations->is_forbidden ($_->get_target)) {
	$bad++;
    }
}

print "$bad:$all = ", $bad/$all, "\n";
