use CELEX;
use StimulusSet;


($A) = &StimulusSet::from_text (
    'StimulusSet', 
    '  Stimulus 1 10',
    '    (L PrWd R)',
    '      (+<alpha> Syllable)',
    '      *L Syllable R*',
    '        [+Root]',
    '          [+lateral]',
    '        *+Root*',
    '          [+Place]',
    '            [+Dor]',
    '              [+high]',
    '              [+back]',
    '          [+Lar]',
    '            [+<beta> voiced]',
    '      (L Syllable R)',
    '        *+Root*',
    '          [+<gamma> Place]',
    '          [+Lar]',
    '            [+voiced]',
    '  Stimulus -1 5',
    '    (L PrWd R)',
    '      (L Syllable R)',
    '        *+Root*',
    '          [+<gamma> Place]',
    '          [+Lar]',
    '            [+voiced]',
    '      (+<alpha> Syllable)',
    '      *L Syllable R*',
    '        [+Root]',
    '          [+lateral]',
    '        *+Root*',
    '          [+Place]',
    '            [+Dor]',
    '              [+high]',
    '              [+back]',
    '          [+Lar]',
    '            [+<beta> voiced]',
    );

#$A->print;
#($A_prime) = &StimulusSet::from_text ($A->to_text);
#$A_prime->print;

#for (1..10) {
#    $A->get_one->print;
#}


@stims = (
    "\'pIb",
    "\'tId",
    "\'kIg",
    "\'p{b",
    "\'t{d",
    "\'k{g",
    "\'pVb",
    "\'tVd",
    "\'kVg"
    );

$SS = new StimulusSet;
for (@stims) {
    $SS->put (new Stimulus (&CELEX::to_representation ($_), 1, 1));
}

#$SS->print;
print "\n";

@text = ($SS->to_text); 
#print (join "\n", @text);

($SS2) = &StimulusSet::from_text (\@text);
$SS2->print;
die;

$SS2->print;
print "\n";


